---
title: ReadableStream.getReader()
slug: Web/API/ReadableStream/getReader
tags:
  - API
  - Method
  - ReadableStream
  - Reference
  - Streams
  - getReader
---
<div>{{APIRef("Streams")}}</div>

<p class="summary">The <strong><code>getReader()</code></strong> method of the {{domxref("ReadableStream")}} interface creates a reader and locks the stream to it. While the stream is locked, no other reader can be acquired until this one is released.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">var <em>reader</em> = <em>readableStream</em>.getReader(<em>{mode}</em>);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt>{mode} {{optional_inline}}</dt>
 <dd>An object containing a property <code>mode</code>, specifying the type of reader to create.  Values can be:
 <ul>
  <li><code>"byob"</code>, which results in a {{domxref("ReadableStreamBYOBReader")}} being created that can read readable byte streams (i.e. can handle "bring your own buffer" reading).</li>
  <li><code>undefined</code> (or not specified at all — this is the default), which results in a {{domxref("ReadableStreamDefaultReader")}} being created that can read individual chunks from a stream.</li>
 </ul>
 </dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A {{domxref("ReadableStreamDefaultReader")}} or {{domxref("ReadableStreamBYOBReader")}} object instance, depending on the <code>mode</code> value.</p>

<h3 id="Exceptions">Exceptions</h3>

<dl>
 <dt>RangeError</dt>
 <dd>The provided mode value is not <code>"byob"</code> or <code>undefined</code>.</dd>
 <dt>TypeError</dt>
 <dd>The stream you are trying to create a reader for is not a {{domxref("ReadableStream")}}.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>In the following simple example, a previously-created custom <code>ReadableStream</code> is read using a {{domxref("ReadableStreamDefaultReader")}} created using <code>getReader()</code>. (see our <a href="https://mdn.github.io/dom-examples/streams/simple-random-stream/">Simple random stream example</a> for the full code). Each chunk is read sequentially and output to the UI, until the stream has finished being read, at which point we return out of the recursive function and print the entire stream to another part of the UI.</p>

<pre class="brush: js notranslate">function fetchStream() {
  const reader = stream.getReader();
  let charsReceived = 0;

  // read() returns a promise that resolves
  // when a value has been received
  reader.read().then(function processText({ done, value }) {
    // Result objects contain two properties:
    // done  - true if the stream has already given you all its data.
    // value - some data. Always undefined when done is true.
    if (done) {
      console.log("Stream complete");
      para.textContent = value;
      return;
    }

    // value for fetch streams is a Uint8Array
    charsReceived += value.length;
    const chunk = value;
    let listItem = document.createElement('li');
    listItem.textContent = 'Received ' + charsReceived + ' characters so far. Current chunk = ' + chunk;
    list2.appendChild(listItem);

    result += chunk;

    // Read some more, and call this function again
    return reader.read().then(processText);
  });
}</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName("Streams","#rs-get-reader","getReader()")}}</td>
   <td>{{Spec2('Streams')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div class="hidden">
<p>The compatibility table on this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>
</div>

<p>{{Compat("api.ReadableStream.getReader")}}</p>
